import { GenericFunction } from "./interfaces";

interface BackArgs {
    back?: GenericFunction<void>;
    forward?: GenericFunction<void>;
    changeUrl?: boolean | string;
}


export declare function getHash(): string;
export declare function setHash(h: string): void;

/**
 * private method. Do not call this directly.
 */
export declare function goBack(): void;

/**
 * private method. Do not call this directly.
 */
export declare function goForward(): void;

/**
 * Initializes the undo stack. This must be called from a <script>
 * block that lives inside the `<body>` tag to prevent bugs on IE.
 * Only call this method before the page's DOM is finished loading. Otherwise
 * it will not work. Be careful with xdomain loading or djConfig.debugAtAllCosts scenarios,
 * in order for this method to work, dojo/back will need to be part of a build layer.
 */
export declare function init(): void;

/**
 * Sets the state object and back callback for the very first page
 * that is loaded.
 * It is recommended that you call this method as part of an event
 * listener that is registered via dojo/ready.
 */
export declare function setInitialState(args: BackArgs): void;

/**
 * adds a state object (args) to the history list.
 */
export declare function addToHistory(args: BackArgs): void;

/**
 * private method. Do not call this directly.
 */
export declare function _iframeLoaded(evt: Event, ifrLoc: Location): void;

